package de.telefonbuch.model;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

public class Datenbank {

	private Connection con;

	public Datenbank() {
		try {
			this.connect();
			this.createTables();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	private void createTables() throws SQLException {
		Statement stmt = this.con.createStatement();
		String createTable = "CREATE TABLE IF NOT EXISTS \"kontakte\" (" +
				"id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, " +
				"vorname VARCHAR(50) NULL, " +
				"nachname VARCHAR(50) NULL, " +
				"strasse VARCHAR(50) NULL, " +
				"hnr VARCHAR(10) NULL, " +
				"plz VARCHAR(5) NULL, " +
				"ort VARCHAR(50) NULL, " +
				"telefon VARCHAR(30) UNIQUE NULL" +
				");";
		System.out.println(stmt.execute(createTable));
	}

	/**
	 * Verbindung zur Datenbank aufbauen
	 */
	private void connect() throws SQLException {
		String datenbankdatei = "c:\\temp\\telefonbuch.sqlite";

		this.con = DriverManager.getConnection("jdbc:sqlite:" + datenbankdatei);
		System.out.println("Erfolgreich mit Datenbank verbunden.");
	}

	public void addKontakt(Kontakt kontakt) {
		try {
			Statement stmt = this.con.createStatement();

			String insertKontakt = "INSERT OR REPLACE INTO kontakte (vorname, nachname, strasse, hnr, plz, ort, telefon) VALUES (" +
					"\"" + kontakt.getVorname() + "\", " +
					"\"" + kontakt.getNachname() + "\", " +
					"\"" + kontakt.getStrasse() + "\", " +
					"\"" + kontakt.getHausnummer() + "\", " +
					"\"" + kontakt.getPlz() + "\", " +
					"\"" + kontakt.getOrt() + "\", " +
					"\"" + kontakt.getTelefon() + "\" " +
					");";
			System.out.println(stmt.execute(insertKontakt));
		} catch (SQLException e) {
			e.printStackTrace();
		}

	}
}
